VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "IADS Data Export"
   ClientHeight    =   4545
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8235
   LinkTopic       =   "Form1"
   ScaleHeight     =   4545
   ScaleWidth      =   8235
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   375
      Left            =   2040
      TabIndex        =   10
      Top             =   4080
      Width           =   4215
      _ExtentX        =   7435
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   1
   End
   Begin MSComctlLib.ListView ParameterList 
      Height          =   3015
      Left            =   240
      TabIndex        =   9
      Top             =   600
      Width           =   3975
      _ExtentX        =   7011
      _ExtentY        =   5318
      View            =   3
      LabelEdit       =   1
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   1
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Parameter"
         Object.Width           =   6438
      EndProperty
   End
   Begin VB.TextBox OutputFileTxt 
      Height          =   285
      Left            =   5760
      TabIndex        =   8
      Text            =   "DataExport.csv"
      Top             =   1560
      Width           =   2175
   End
   Begin VB.CommandButton ExportBtn 
      Caption         =   "Export"
      Height          =   375
      Left            =   5640
      TabIndex        =   6
      Top             =   3000
      Width           =   1215
   End
   Begin VB.TextBox OutputDirTxt 
      Height          =   285
      Left            =   4440
      TabIndex        =   5
      Top             =   2280
      Width           =   3495
   End
   Begin VB.TextBox StopTimeTxt 
      Height          =   285
      Left            =   5280
      TabIndex        =   3
      Top             =   1080
      Width           =   2655
   End
   Begin VB.TextBox StartTimeTxt 
      Height          =   285
      Left            =   5280
      TabIndex        =   1
      Top             =   600
      Width           =   2655
   End
   Begin VB.Label ProgressLbl 
      Alignment       =   2  'Center
      Caption         =   "Export Progress"
      Height          =   255
      Left            =   3360
      TabIndex        =   11
      Top             =   3840
      Width           =   1575
   End
   Begin VB.Label Label5 
      Caption         =   "Output File Name:"
      Height          =   255
      Left            =   4440
      TabIndex        =   7
      Top             =   1560
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "Output Directory:"
      Height          =   255
      Left            =   4440
      TabIndex        =   4
      Top             =   2040
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "Stop Time:"
      Height          =   255
      Left            =   4440
      TabIndex        =   2
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Start Time:"
      Height          =   255
      Left            =   4440
      TabIndex        =   0
      Top             =   600
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *****************************************************************************
'
' Copyright. 2008. Symvionics, Inc. All rights reserved.
'
' Symvionics Inc. ("Symvionics") grants a non-exclusive license for you to use
' this source code and the accompanying documentation, if any, free of charge,
' provided that this paragraph, and the following two paragraphs appear in all
' copies and in all derivative works.  In no event shall this source code or
' this license thereto impact upon or fall within the scope of any other
' agreement that you have with Symvionics.
'
' BY USING THIS SOFTWARE, YOU FURTHER AGREE THAT, IN NO EVENT, SHALL SYMVIONICS
' BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
' CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
' SOFTWARE, THE ACCOMPANYING DOCUMENTATION, IF ANY, OR ANY DERIVATIVE WORKS.
' YOU AGREE TO DEFEND, INDEMNIFY, AND HOLD HARMLESS SYMVIONICS FROM AND AGAINST
' ALL FINES, PENALTIES, LIABILITIES, DAMAGES, COSTS, AND EXPENSES INCURRED
' BY SYMVIONICS AS A RESULT OF YOUR USE OF THIS SOFTWARE INCLUDING THIRD PARTY
' USE OF ANY DERIVATIVE WORKS CREATED BY YOU.
'
' SYMVIONICS SPECIFICALLY DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING, BUT NOT
' LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
' PARTICULAR PURPOSE.  THE SOFTWARE AND ACCOMPANYING DOCUMENTATION LICENSED
' HEREUNDER ARE PROVIDED "AS IS" WITHOUT WARRANTY OR OBLIGATION OF SUPPORT OR
' MAINTENANCE.
'
' ****************************************************************************
Dim gNumSelectedParams As Integer
Dim gIads
Dim gConfig
Dim gIsExporting


Private Sub ExportBtn_Click()

    If (gIsExporting <> True) Then
        If (ValidateInput()) Then
            gIsExporting = True
            Screen.MousePointer = vbHourglass
            ExportBtn.Enabled = False
            PerformDataExport
            gIsExporting = False
            Screen.MousePointer = vbDefault
            ExportBtn.Enabled = True
        End If
    End If
    
End Sub

Private Sub Form_Load()

    gIsExporting = False
    
    ' Initialize an instance of the IADS application.
    ' This will connect to an already running IADS client.
    Set gIads = CreateObject("Iads.Application")
    Set gConfig = gIads.Configuration
    
    ' Query for the TPP parameters in the currently loaded config file
    Set results = gConfig.SqlQuery("select Parameter from ParameterDefaults")
    
    ' Populate the list with parameter names
    Dim index As Variant
    For index = 0 To results.Count - 1
        Set result = results.Item(CInt(index))
        ' We only asked for one field from the database (the 'Parameter' field)
        ' so the index into the result here will always be 0
        Set Item = ParameterList.ListItems.Add
        Item.Text = result.Item(0)
    Next
    
End Sub
' Validates the input entered by the user. Ensures that parameters
' have been selected, start/stop times specified, etc.
Private Function ValidateInput()

    isInputValid = True
    
    If (ParameterList.ListItems.Count = 0) Then
        MsgBox ("No parameters available to export. Make sure you are already running IADS with a valid config file.")
        isInputValid = False
    ElseIf (Trim(ParameterList.SelectedItem) = "") Then
        MsgBox ("Please select at least one parameter for export.")
        isInputValid = False
    ElseIf (Len(Trim(StartTimeTxt.Text)) = 0) Then
        MsgBox ("Please specify an export start time.")
        isInputValid = False
    ElseIf (Len(Trim(StopTimeTxt.Text)) = 0) Then
        MsgBox ("Please specify an export stop time.")
        isInputValid = False
    ElseIf (Len(Trim(OutputFileTxt.Text)) = 0) Then
        MsgBox ("Please specify an output file name.")
        isInputValid = False
    ElseIf (Len(Trim(OutputDirTxt.Text)) = 0) Then
        MsgBox ("Please specify an output directory.")
        isInputValid = False
    End If
    
    ValidateInput = isInputValid
End Function
' Exports the data for the selected parameters to the specified
' output file, using the specified start/stop times.
Sub PerformDataExport()

    gNumSelectedParams = GetNumSelectedParams()
    Dim paramsToExport()
    ReDim paramsToExport(0 To gNumSelectedParams)
    Dim paramNames()
    ReDim paramNames(0 To gNumSelectedParams)
    
    ' Initialize the parameters selected for export
    If (InitExportParams(paramsToExport, paramNames)) Then
        
        ' Initialize the start/end times
        Set startTime = CreateObject("IadsTime.IadsTime")
        Set endTime = CreateObject("IadsTime.IadsTime")
        startTime.TimeString = StartTimeTxt.Text
        endTime.TimeString = StopTimeTxt.Text
        
        If (startTime.TotalNanoseconds < endTime.TotalNanoseconds) Then
        
            ProgressLbl.Caption = "Exporting..."
            ProgressBar1.Value = 1
        
            ' Creates a FileSystemObject we can use to write data to CSV files
            Set gFSO = CreateObject("Scripting.FileSystemObject")
        
            ' Make sure the output path has a backslash on the end
            fName = OutputFileTxt.Text
            fDir = OutputDirTxt.Text
            If (Right(fDir, 1) <> "\") Then
                fDir = fDir & "\"
            End If
            
            'Open the file to write to
            Set gFile = gFSO.OpenTextFile(fDir & fName, 2, True)
            
            ' Write out the file header (parameter names) and get the highest parameter sample rate
            SampleRate = -1#
            gFile.Write ("TIME")
            For i = 0 To gNumSelectedParams - 1
                sr = paramsToExport(i).SampleRate
                If (SampleRate < sr) Then
                    SampleRate = sr
                End If
                
                gFile.Write ("," & paramNames(i))
            Next
            gFile.WriteLine
            
            ' Set the sample rate on all of the params to the highest sample rate so we "square off"
            ' all the data and get a matching number of data values for all of the parameters
            For j = 0 To UBound(paramsToExport) - 1
                paramsToExport(j).InterpolatedSampleRate = SampleRate
                paramsToExport(j).CurrentTime = startTime
            Next
                
            Set thisTime = CreateObject("IadsTime.IadsTime")
            thisTime.SetTime (startTime)
            
            ProgressBar1.Min = 1
            ProgressBar1.Max = CInt((endTime.TotalSeconds - startTime.TotalSeconds) * SampleRate + 1)
            
            Dim ParamData()
            ReDim ParamData(0 To gNumSelectedParams)
            
            For i = 0 To gNumSelectedParams - 1
                ParamData(i) = paramsToExport(i).ValuesInTimeRange(startTime, endTime)
            Next
            
            ' Write out the data, row by row
            dataIndex = 0
            Do While thisTime.TotalSeconds < endTime.TotalSeconds
                gFile.Write (thisTime.TimeString)
                For paramIndex = 0 To UBound(paramsToExport) - 1
                    gFile.Write ("," & ParamData(paramIndex)(dataIndex))
                Next
                dataIndex = dataIndex + 1
                thisTime.AdvanceTime 1, SampleRate
                gFile.WriteLine
                If (ProgressBar1.Value < ProgressBar1.Max) Then
                    ProgressBar1.Value = ProgressBar1.Value + 1
                End If
            Loop
            
            Set thisTime = Nothing
            
            'Close the export file
            gFile.Close
            Set gFile = Nothing
            ProgressBar1.Value = 1
            ProgressLbl.Caption = "Export Progress"
            
            MsgBox ("Successfully exported data to " & fDir & fName)
        Else
            MsgBox ("Error: Stop time must be greater than start time!")
        End If
    Else
        MsgBox ("Error: Failed to initialize selected export parameters - verify that they exist in your configuration file.")
    End If
End Sub

' This function initializes the parameters that will be used to export data to a CSV file.
' It returns True if all parameters are imported successfully, False if there are any errors.
Function InitExportParams(ByRef params, ByRef names)
    InitSuccess = True
    
    paramIndex = 0
    For index = 1 To ParameterList.ListItems.Count
        If (ParameterList.ListItems.Item(index).Selected) Then
            names(paramIndex) = ParameterList.ListItems.Item(index).Text
            ' This creates an IADS parameter in VB. This will fail if the specified parameter doesn't exist.
            Set params(paramIndex) = gConfig.CreateParameter(ParameterList.ListItems.Item(index).Text)
    
            ' Make sure the parameter was created properly
            If Err.Number <> 0 Then
                InitSuccess = False
            End If
    
            ' Need to do this so we can access data in the parameter from VB.
            params(paramIndex).VBScriptDataCompatibility = True
            paramIndex = paramIndex + 1
        End If
    Next
        
    InitExportParams = InitSuccess
End Function
' Gets the number of parameters selected in the parameter list.
Function GetNumSelectedParams()
    numSelected = 0
    For index = 1 To ParameterList.ListItems.Count
        If (ParameterList.ListItems.Item(index).Selected) Then
            numSelected = numSelected + 1
        End If
    Next
    GetNumSelectedParams = numSelected
End Function

